diff -rNci gcc-2.7.2/config/i386/i386.c gcc-2.7.2p/config/i386/i386.c
*** gcc-2.7.2/config/i386/i386.c	Sun Oct 22 11:13:21 1995
--- gcc-2.7.2p/config/i386/i386.c	Tue Jan 23 09:34:59 1996
***************
*** 1,6 ****
--- 1,9 ----
  /* Subroutines for insn-output.c for Intel X86.
     Copyright (C) 1988, 1992, 1994, 1995 Free Software Foundation, Inc.
  
+    Pentium cpu support and other enhancements by Tevi Devor Intel Corp.
+    (tevi@iil.intel.com).
+   
  This file is part of GNU CC.
  
  GNU CC is free software; you can redistribute it and/or modify
***************
*** 35,40 ****
--- 38,45 ----
  #include "flags.h"
  #include "function.h"
  
+ /* intel1 Need the EXTRA_CONSTRAINT - changed s to */
+ #if 0
  #ifdef EXTRA_CONSTRAINT
  /* If EXTRA_CONSTRAINT is defined, then the 'S'
     constraint in REG_CLASS_FROM_LETTER will no longer work, and various
***************
*** 43,48 ****
--- 48,57 ----
  /* The previous line used to be #error, but some compilers barf
     even if the conditional was untrue.  */
  #endif
+ #endif
+ 
+ /* which cpu are we scheduling for intel1*/
+ enum processor_type x86_cpu;
  
  #define AT_BP(mode) (gen_rtx (MEM, (mode), frame_pointer_rtx))
  
***************
*** 53,88 ****
  char *output_move_const_single ();
  char *output_fp_cc0_set ();
  
  char *hi_reg_name[] = HI_REGISTER_NAMES;
  char *qi_reg_name[] = QI_REGISTER_NAMES;
  char *qi_high_reg_name[] = QI_HIGH_REGISTER_NAMES;
  
- /* Array of the smallest class containing reg number REGNO, indexed by
-    REGNO.  Used by REGNO_REG_CLASS in i386.h. */
- 
- enum reg_class regclass_map[FIRST_PSEUDO_REGISTER] =
- {
-   /* ax, dx, cx, bx */
-   AREG, DREG, CREG, BREG,
-   /* si, di, bp, sp */
-   SIREG, DIREG, INDEX_REGS, GENERAL_REGS,
-   /* FP registers */
-   FP_TOP_REG, FP_SECOND_REG, FLOAT_REGS, FLOAT_REGS,
-   FLOAT_REGS, FLOAT_REGS, FLOAT_REGS, FLOAT_REGS,       
-   /* arg pointer */
-   INDEX_REGS
- };
- 
- /* Test and compare insns in i386.md store the information needed to
-    generate branch and scc insns here.  */
- 
- struct rtx_def *i386_compare_op0 = NULL_RTX;
- struct rtx_def *i386_compare_op1 = NULL_RTX;
- struct rtx_def *(*i386_compare_gen)(), *(*i386_compare_gen_eq)();
- 
  /* Register allocation order */
  char *i386_reg_alloc_order;
! static char regs_allocated[FIRST_PSEUDO_REGISTER];
  
  /* # of registers to use to pass arguments. */
  char *i386_regparm_string;			/* # registers to use to pass args */
--- 62,77 ----
  char *output_move_const_single ();
  char *output_fp_cc0_set ();
  
+ /* intel1 */
+ static int opt_level=0;
+ 
  char *hi_reg_name[] = HI_REGISTER_NAMES;
  char *qi_reg_name[] = QI_REGISTER_NAMES;
  char *qi_high_reg_name[] = QI_HIGH_REGISTER_NAMES;
  
  /* Register allocation order */
  char *i386_reg_alloc_order;
! /*static char regs_allocated[FIRST_PSEUDO_REGISTER];*/
  
  /* # of registers to use to pass arguments. */
  char *i386_regparm_string;			/* # registers to use to pass args */
***************
*** 97,284 ****
  int i386_align_jumps;				/* power of two alignment for non-loop jumps */
  int i386_align_funcs;				/* power of two alignment for functions */
  
! 
! /* Sometimes certain combinations of command options do not make
!    sense on a particular target machine.  You can define a macro
!    `OVERRIDE_OPTIONS' to take account of this.  This macro, if
!    defined, is executed once just after all the command options have
!    been parsed.
! 
!    Don't use this macro to turn on various extra optimizations for
!    `-O'.  That is what `OPTIMIZATION_OPTIONS' is for.  */
! 
! void
! override_options ()
! {
!   int ch, i, regno;
!   char *p;
!   int def_align;
! 
! #ifdef SUBTARGET_OVERRIDE_OPTIONS
!   SUBTARGET_OVERRIDE_OPTIONS;
! #endif
! 
!   /* Validate registers in register allocation order */
!   if (i386_reg_alloc_order)
!     {
!       for (i = 0; (ch = i386_reg_alloc_order[i]) != '\0'; i++)
! 	{
! 	  switch (ch)
! 	    {
! 	    case 'a':	regno = 0;	break;
! 	    case 'd':	regno = 1;	break;
! 	    case 'c':	regno = 2;	break;
! 	    case 'b':	regno = 3;	break;
! 	    case 'S':	regno = 4;	break;
! 	    case 'D':	regno = 5;	break;
! 	    case 'B':	regno = 6;	break;
! 
! 	    default:	fatal ("Register '%c' is unknown", ch);
! 	    }
! 
! 	  if (regs_allocated[regno])
! 	    fatal ("Register '%c' was already specified in the allocation order", ch);
! 
! 	  regs_allocated[regno] = 1;
! 	}
!     }
! 
!   /* Validate -mregparm= value */
!   if (i386_regparm_string)
!     {
!       i386_regparm = atoi (i386_regparm_string);
!       if (i386_regparm < 0 || i386_regparm > REGPARM_MAX)
! 	fatal ("-mregparm=%d is not between 0 and %d", i386_regparm, REGPARM_MAX);
!     }
! 
!   def_align = (TARGET_386) ? 2 : 4;
! 
!   /* Validate -malign-loops= value, or provide default */
!   if (i386_align_loops_string)
!     {
!       i386_align_loops = atoi (i386_align_loops_string);
!       if (i386_align_loops < 0 || i386_align_loops > MAX_CODE_ALIGN)
! 	fatal ("-malign-loops=%d is not between 0 and %d",
! 	       i386_align_loops, MAX_CODE_ALIGN);
!     }
!   else
!     i386_align_loops = 2;
! 
!   /* Validate -malign-jumps= value, or provide default */
!   if (i386_align_jumps_string)
!     {
!       i386_align_jumps = atoi (i386_align_jumps_string);
!       if (i386_align_jumps < 0 || i386_align_jumps > MAX_CODE_ALIGN)
! 	fatal ("-malign-jumps=%d is not between 0 and %d",
! 	       i386_align_jumps, MAX_CODE_ALIGN);
!     }
!   else
!     i386_align_jumps = def_align;
! 
!   /* Validate -malign-functions= value, or provide default */
!   if (i386_align_funcs_string)
!     {
!       i386_align_funcs = atoi (i386_align_funcs_string);
!       if (i386_align_funcs < 0 || i386_align_funcs > MAX_CODE_ALIGN)
! 	fatal ("-malign-functions=%d is not between 0 and %d",
! 	       i386_align_funcs, MAX_CODE_ALIGN);
!     }
!   else
!     i386_align_funcs = def_align;
! }
! 
! /* A C statement (sans semicolon) to choose the order in which to
!    allocate hard registers for pseudo-registers local to a basic
!    block.
! 
!    Store the desired register order in the array `reg_alloc_order'.
!    Element 0 should be the register to allocate first; element 1, the
!    next register; and so on.
! 
!    The macro body should not assume anything about the contents of
!    `reg_alloc_order' before execution of the macro.
! 
!    On most machines, it is not necessary to define this macro.  */
  
! void
! order_regs_for_local_alloc ()
  {
!   int i, ch, order, regno;
! 
!   /* User specified the register allocation order */
!   if (i386_reg_alloc_order)
!     {
!       for (i = order = 0; (ch = i386_reg_alloc_order[i]) != '\0'; i++)
! 	{
! 	  switch (ch)
! 	    {
! 	    case 'a':	regno = 0;	break;
! 	    case 'd':	regno = 1;	break;
! 	    case 'c':	regno = 2;	break;
! 	    case 'b':	regno = 3;	break;
! 	    case 'S':	regno = 4;	break;
! 	    case 'D':	regno = 5;	break;
! 	    case 'B':	regno = 6;	break;
! 	    }
! 
! 	  reg_alloc_order[order++] = regno;
! 	}
! 
!       for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
! 	{
! 	  if (!regs_allocated[i])
! 	    reg_alloc_order[order++] = i;
! 	}
!     }
! 
!   /* If users did not specify a register allocation order, favor eax
!      normally except if DImode variables are used, in which case
!      favor edx before eax, which seems to cause less spill register
!      not found messages.  */
!   else
!     {
!       rtx insn;
! 
!       for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
! 	reg_alloc_order[i] = i;
! 
!       if (optimize)
! 	{
! 	  int use_dca = FALSE;
! 
! 	  for (insn = get_insns (); insn; insn = NEXT_INSN (insn))
! 	    {
! 	      if (GET_CODE (insn) == INSN)
! 		{
! 		  rtx set = NULL_RTX;
! 		  rtx pattern = PATTERN (insn);
! 
! 		  if (GET_CODE (pattern) == SET)
! 		    set = pattern;
! 
! 		  else if ((GET_CODE (pattern) == PARALLEL
! 			    || GET_CODE (pattern) == SEQUENCE)
! 			   && GET_CODE (XVECEXP (pattern, 0, 0)) == SET)
! 		    set = XVECEXP (pattern, 0, 0);
! 
! 		  if (set && GET_MODE (SET_SRC (set)) == DImode)
! 		    {
! 		      use_dca = TRUE;
! 		      break;
! 		    }
! 		}
! 	    }
  
! 	  if (use_dca)
! 	    {
! 	      reg_alloc_order[0] = 1;	/* edx */
! 	      reg_alloc_order[1] = 2;	/* ecx */
! 	      reg_alloc_order[2] = 0;	/* eax */
! 	    }
! 	}
!     }
! }
  
  
  /* Return nonzero if IDENTIFIER with arguments ARGS is a valid machine specific
     attribute for DECL.  The attributes in ATTRIBUTES have previously been
--- 86,112 ----
  int i386_align_jumps;				/* power of two alignment for non-loop jumps */
  int i386_align_funcs;				/* power of two alignment for functions */
  
! /* Array of the smallest class containing reg number REGNO, indexed by
!    REGNO.  Used by REGNO_REG_CLASS in i386.h. */
  
! enum reg_class regclass_map[FIRST_PSEUDO_REGISTER] =
  {
!   /* ax, dx, cx, bx */
!   AREG, DREG, CREG, BREG,
!   /* si, di, bp, sp */
!   SIREG, DIREG, INDEX_REGS, GENERAL_REGS,
!   /* FP registers */
!   FP_TOP_REG, FP_SECOND_REG, FLOAT_REGS, FLOAT_REGS,
!   FLOAT_REGS, FLOAT_REGS, FLOAT_REGS, FLOAT_REGS,       
!   /* arg pointer */
!   INDEX_REGS
! };
  
! /* Test and compare insns in i386.md store the information needed to
!    generate branch and scc insns here.  */
  
+ struct rtx_def *i386_compare_op0, *i386_compare_op1;
+ struct rtx_def *(*i386_compare_gen)(), *(*i386_compare_gen_eq)();
  
  /* Return nonzero if IDENTIFIER with arguments ARGS is a valid machine specific
     attribute for DECL.  The attributes in ATTRIBUTES have previously been
***************
*** 635,640 ****
--- 463,469 ----
       int dies;
  {
    rtx xops[4];
+   int def_align;
    int size = GET_MODE_SIZE (GET_MODE (dest));
  
    xops[0] = AT_SP (Pmode);
***************
*** 681,686 ****
--- 510,558 ----
  	  output_asm_insn (AS1 (pop%L0,%0), &dest);
  	}
      }
+ 
+   /* Validate -mregparm= value */
+   if (i386_regparm_string)
+     {
+       i386_regparm = atoi (i386_regparm_string);
+       if (i386_regparm < 0 || i386_regparm > REGPARM_MAX)
+ 	fatal ("-mregparm=%d is not between 0 and %d", i386_regparm, REGPARM_MAX);
+     }
+ 
+   def_align = (TARGET_386) ? 2 : 4;
+ 
+   /* Validate -malign-loops= value, or provide default */
+   if (i386_align_loops_string)
+     {
+       i386_align_loops = atoi (i386_align_loops_string);
+       if (i386_align_loops < 0 || i386_align_loops > MAX_CODE_ALIGN)
+ 	fatal ("-malign-loops=%d is not between 0 and %d",
+ 	       i386_align_loops, MAX_CODE_ALIGN);
+     }
+   else
+     i386_align_loops = 2;
+ 
+   /* Validate -malign-jumps= value, or provide default */
+   if (i386_align_jumps_string)
+     {
+       i386_align_jumps = atoi (i386_align_jumps_string);
+       if (i386_align_jumps < 0 || i386_align_jumps > MAX_CODE_ALIGN)
+ 	fatal ("-malign-jumps=%d is not between 0 and %d",
+ 	       i386_align_jumps, MAX_CODE_ALIGN);
+     }
+   else
+     i386_align_jumps = def_align;
+ 
+   /* Validate -malign-functions= value, or provide default */
+   if (i386_align_funcs_string)
+     {
+       i386_align_funcs = atoi (i386_align_funcs_string);
+       if (i386_align_funcs < 0 || i386_align_funcs > MAX_CODE_ALIGN)
+ 	fatal ("-malign-functions=%d is not between 0 and %d",
+ 	       i386_align_funcs, MAX_CODE_ALIGN);
+     }
+   else
+     i386_align_funcs = def_align;
  }
  
  char *
***************
*** 735,741 ****
    abort ();
  }
  
- 
  /* Output an insn to add the constant N to the register X.  */
  
  static void
--- 607,612 ----
***************
*** 744,768 ****
       rtx x;
  {
    rtx xops[2];
!   xops[0] = x;
! 
!   if (n == -1)
!     output_asm_insn (AS1 (dec%L0,%0), xops);
!   else if (n == 1)
!     output_asm_insn (AS1 (inc%L0,%0), xops);
!   else if (n < 0)
      {
!       xops[1] = GEN_INT (-n);
!       output_asm_insn (AS2 (sub%L0,%1,%0), xops);
      }
    else if (n > 0)
      {
!       xops[1] = GEN_INT (n);
!       output_asm_insn (AS2 (add%L0,%1,%0), xops);
      }
  }
  
- 
  /* Output assembler code to perform a doubleword move insn
     with operands OPERANDS.  */
  
--- 615,633 ----
       rtx x;
  {
    rtx xops[2];
!   xops[1] = x;
!   if (n < 0)
      {
!       xops[0] = GEN_INT (-n);
!       output_asm_insn (AS2 (sub%L0,%0,%1), xops);
      }
    else if (n > 0)
      {
!       xops[0] = GEN_INT (n);
!       output_asm_insn (AS2 (add%L0,%0,%1), xops);
      }
  }
  
  /* Output assembler code to perform a doubleword move insn
     with operands OPERANDS.  */
  
***************
*** 1081,1342 ****
  
    return "";
  }
- 
  
! #define MAX_TMPS 2		/* max temporary registers used */
! 
! /* Output the appropriate code to move push memory on the stack */
! 
! char *
! output_move_pushmem (operands, insn, length, tmp_start, n_operands)
!      rtx operands[];
!      rtx insn;
!      int length;
!      int tmp_start;
!      int n_operands;
  {
  
!   struct {
!     char *load;
!     char *push;
!     rtx   xops[2];
!   } tmp_info[MAX_TMPS];
! 
!   rtx src = operands[1];
!   int max_tmps = 0;
!   int offset = 0;
!   int stack_p = reg_overlap_mentioned_p (stack_pointer_rtx, src);
!   int stack_offset = 0;
!   int i, num_tmps;
!   rtx xops[1];
  
!   if (!offsettable_memref_p (src))
!     fatal_insn ("Source is not offsettable", insn);
  
!   if ((length & 3) != 0)
!     fatal_insn ("Pushing non-word aligned size", insn);
  
!   /* Figure out which temporary registers we have available */
!   for (i = tmp_start; i < n_operands; i++)
!     {
!       if (GET_CODE (operands[i]) == REG)
! 	{
! 	  if (reg_overlap_mentioned_p (operands[i], src))
! 	    continue;
  
! 	  tmp_info[ max_tmps++ ].xops[1] = operands[i];
! 	  if (max_tmps == MAX_TMPS)
! 	    break;
! 	}
!     }
  
!   if (max_tmps == 0)
!     for (offset = length - 4; offset >= 0; offset -= 4)
!       {
! 	xops[0] = adj_offsettable_operand (src, offset + stack_offset);
! 	output_asm_insn (AS1(push%L0,%0), xops);
! 	if (stack_p)
! 	  stack_offset += 4;
!       }
  
!   else
!     for (offset = length - 4; offset >= 0; )
!       {
! 	for (num_tmps = 0; num_tmps < max_tmps && offset >= 0; num_tmps++)
! 	  {
! 	    tmp_info[num_tmps].load    = AS2(mov%L0,%0,%1);
! 	    tmp_info[num_tmps].push    = AS1(push%L0,%1);
! 	    tmp_info[num_tmps].xops[0] = adj_offsettable_operand (src, offset + stack_offset);
! 	    offset -= 4;
! 	  }
  
! 	for (i = 0; i < num_tmps; i++)
! 	  output_asm_insn (tmp_info[i].load, tmp_info[i].xops);
  
! 	for (i = 0; i < num_tmps; i++)
! 	  output_asm_insn (tmp_info[i].push, tmp_info[i].xops);
  
! 	if (stack_p)
! 	  stack_offset += 4*num_tmps;
!       }
  
!   return "";
  }
- 
  
! 
! /* Output the appropriate code to move data between two memory locations */
! 
! char *
! output_move_memory (operands, insn, length, tmp_start, n_operands)
!      rtx operands[];
!      rtx insn;
!      int length;
!      int tmp_start;
!      int n_operands;
! {
!   struct {
!     char *load;
!     char *store;
!     rtx   xops[3];
!   } tmp_info[MAX_TMPS];
! 
!   rtx dest = operands[0];
!   rtx src  = operands[1];
!   rtx qi_tmp = NULL_RTX;
!   int max_tmps = 0;
!   int offset = 0;
!   int i, num_tmps;
!   rtx xops[3];
! 
!   if (GET_CODE (dest) == MEM
!       && GET_CODE (XEXP (dest, 0)) == PRE_INC
!       && XEXP (XEXP (dest, 0), 0) == stack_pointer_rtx)
!     return output_move_pushmem (operands, insn, length, tmp_start, n_operands);
! 
!   if (!offsettable_memref_p (src))
!     fatal_insn ("Source is not offsettable", insn);
! 
!   if (!offsettable_memref_p (dest))
!     fatal_insn ("Destination is not offsettable", insn);
! 
!   /* Figure out which temporary registers we have available */
!   for (i = tmp_start; i < n_operands; i++)
!     {
!       if (GET_CODE (operands[i]) == REG)
! 	{
! 	  if ((length & 1) != 0 && !qi_tmp && QI_REG_P (operands[i]))
! 	    qi_tmp = operands[i];
! 
! 	  if (reg_overlap_mentioned_p (operands[i], dest))
! 	    fatal_insn ("Temporary register overlaps the destination", insn);
! 
! 	  if (reg_overlap_mentioned_p (operands[i], src))
! 	    fatal_insn ("Temporary register overlaps the source", insn);
! 
! 	  tmp_info[ max_tmps++ ].xops[2] = operands[i];
! 	  if (max_tmps == MAX_TMPS)
! 	    break;
! 	}
!     }
! 
!   if (max_tmps == 0)
!     fatal_insn ("No scratch registers were found to do memory->memory moves", insn);
! 
!   if ((length & 1) != 0)
!     {
!       if (!qi_tmp)
! 	fatal_insn ("No byte register found when moving odd # of bytes.", insn);
!     }
! 
!   while (length > 1)
!     {
!       for (num_tmps = 0; num_tmps < max_tmps; num_tmps++)
! 	{
! 	  if (length >= 4)
! 	    {
! 	      tmp_info[num_tmps].load    = AS2(mov%L0,%1,%2);
! 	      tmp_info[num_tmps].store   = AS2(mov%L0,%2,%0);
! 	      tmp_info[num_tmps].xops[0] = adj_offsettable_operand (dest, offset);
! 	      tmp_info[num_tmps].xops[1] = adj_offsettable_operand (src, offset);
! 	      offset += 4;
! 	      length -= 4;
! 	    }
! 	  else if (length >= 2)
! 	    {
! 	      tmp_info[num_tmps].load    = AS2(mov%W0,%1,%2);
! 	      tmp_info[num_tmps].store   = AS2(mov%W0,%2,%0);
! 	      tmp_info[num_tmps].xops[0] = adj_offsettable_operand (dest, offset);
! 	      tmp_info[num_tmps].xops[1] = adj_offsettable_operand (src, offset);
! 	      offset += 2;
! 	      length -= 2;
! 	    }
! 	  else
! 	    break;
! 	}
! 
!       for (i = 0; i < num_tmps; i++)
! 	output_asm_insn (tmp_info[i].load, tmp_info[i].xops);
! 
!       for (i = 0; i < num_tmps; i++)
! 	output_asm_insn (tmp_info[i].store, tmp_info[i].xops);
!     }
! 
!   if (length == 1)
!     {
!       xops[0] = adj_offsettable_operand (dest, offset);
!       xops[1] = adj_offsettable_operand (src, offset);
!       xops[2] = qi_tmp;
!       output_asm_insn (AS2(mov%B0,%1,%2), xops);
!       output_asm_insn (AS2(mov%B0,%2,%0), xops);
!     }
! 
!   return "";
! }
! 
! 
! int
! standard_80387_constant_p (x)
!      rtx x;
! {
! #if ! defined (REAL_IS_NOT_DOUBLE) || defined (REAL_ARITHMETIC)
!   REAL_VALUE_TYPE d;
!   jmp_buf handler;
!   int is0, is1;
! 
!   if (setjmp (handler))
!     return 0;
! 
!   set_float_handler (handler);
!   REAL_VALUE_FROM_CONST_DOUBLE (d, x);
!   is0 = REAL_VALUES_EQUAL (d, dconst0);
!   is1 = REAL_VALUES_EQUAL (d, dconst1);
!   set_float_handler (NULL_PTR);
! 
!   if (is0)
!     return 1;
! 
!   if (is1)
!     return 2;
! 
!   /* Note that on the 80387, other constants, such as pi,
!      are much slower to load as standard constants
!      than to load from doubles in memory!  */
! #endif
! 
!   return 0;
! }
! 
! char *
! output_move_const_single (operands)
!      rtx *operands;
! {
!   if (FP_REG_P (operands[0]))
!     {
!       int conval = standard_80387_constant_p (operands[1]);
! 
!       if (conval == 1)
! 	return "fldz";
! 
!       if (conval == 2)
! 	return "fld1";
!     }
!   if (GET_CODE (operands[1]) == CONST_DOUBLE)
!     {
!       REAL_VALUE_TYPE r; long l;
! 
!       if (GET_MODE (operands[1]) == XFmode)
! 	abort ();
! 
!       REAL_VALUE_FROM_CONST_DOUBLE (r, operands[1]);
!       REAL_VALUE_TO_TARGET_SINGLE (r, l);
!       operands[1] = GEN_INT (l);
!     }
!   return singlemove_string (operands);
! }
! 
! /* Returns 1 if OP is either a symbol reference or a sum of a symbol
!    reference and a constant.  */
  
  int
  symbolic_operand (op, mode)
--- 946,1014 ----
  
    return "";
  }
  
! int
! standard_80387_constant_p (x)
!      rtx x;
  {
+ #if ! defined (REAL_IS_NOT_DOUBLE) || defined (REAL_ARITHMETIC)
+   REAL_VALUE_TYPE d;
+   jmp_buf handler;
+   int is0, is1;
  
!   if (setjmp (handler))
!     return 0;
  
!   set_float_handler (handler);
!   REAL_VALUE_FROM_CONST_DOUBLE (d, x);
!   is0 = REAL_VALUES_EQUAL (d, dconst0);
!   is1 = REAL_VALUES_EQUAL (d, dconst1);
!   set_float_handler (NULL_PTR);
  
!   if (is0)
!     return 1;
  
!   if (is1)
!     return 2;
  
!   /* Note that on the 80387, other constants, such as pi,
!      are much slower to load as standard constants
!      than to load from doubles in memory!  */
! #endif
  
!   return 0;
! }
  
! char *
! output_move_const_single (operands)
!      rtx *operands;
! {
!   if (FP_REG_P (operands[0]))
!     {
!       int conval = standard_80387_constant_p (operands[1]);
  
!       if (conval == 1)
! 	return "fldz";
  
!       if (conval == 2)
! 	return "fld1";
!     }
!   if (GET_CODE (operands[1]) == CONST_DOUBLE)
!     {
!       REAL_VALUE_TYPE r; long l;
  
!       if (GET_MODE (operands[1]) == XFmode)
! 	abort ();
  
!       REAL_VALUE_FROM_CONST_DOUBLE (r, operands[1]);
!       REAL_VALUE_TO_TARGET_SINGLE (r, l);
!       operands[1] = GEN_INT (l);
!     }
!   return singlemove_string (operands);
  }
  
! /* Returns 1 if OP is either a symbol reference or a sum of a symbol
!    reference and a constant.  */
  
  int
  symbolic_operand (op, mode)
***************
*** 1447,1452 ****
--- 1119,1229 ----
    return 0;
  }
  
+ /* Return a legitimate reference for ORIG (an address) using the
+    register REG.  If REG is 0, a new pseudo is generated.
+ 
+    There are three types of references that must be handled:
+ 
+    1. Global data references must load the address from the GOT, via
+       the PIC reg.  An insn is emitted to do this load, and the reg is
+       returned.
+ 
+    2. Static data references must compute the address as an offset
+       from the GOT, whose base is in the PIC reg.  An insn is emitted to
+       compute the address into a reg, and the reg is returned.  Static
+       data objects have SYMBOL_REF_FLAG set to differentiate them from
+       global data objects.
+ 
+    3. Constant pool addresses must be handled special.  They are
+       considered legitimate addresses, but only if not used with regs.
+       When printed, the output routines know to print the reference with the
+       PIC reg, even though the PIC reg doesn't appear in the RTL.
+ 
+    GO_IF_LEGITIMATE_ADDRESS rejects symbolic references unless the PIC
+    reg also appears in the address (except for constant pool references,
+    noted above).
+ 
+    "switch" statements also require special handling when generating
+    PIC code.  See comments by the `casesi' insn in i386.md for details.  */
+ 
+ rtx
+ legitimize_pic_address (orig, reg)
+      rtx orig;
+      rtx reg;
+ {
+   rtx addr = orig;
+   rtx new = orig;
+ 
+   if (GET_CODE (addr) == SYMBOL_REF || GET_CODE (addr) == LABEL_REF)
+     {
+       if (GET_CODE (addr) == SYMBOL_REF && CONSTANT_POOL_ADDRESS_P (addr))
+ 	reg = new = orig;
+       else
+ 	{
+ 	  if (reg == 0)
+ 	    reg = gen_reg_rtx (Pmode);
+ 
+ 	  if (GET_CODE (addr) == SYMBOL_REF && SYMBOL_REF_FLAG (addr))
+ 	    new = gen_rtx (PLUS, Pmode, pic_offset_table_rtx, orig);
+ 	  else
+ 	    new = gen_rtx (MEM, Pmode,
+ 			   gen_rtx (PLUS, Pmode,
+ 				    pic_offset_table_rtx, orig));
+ 
+ 	  emit_move_insn (reg, new);
+ 	}
+       current_function_uses_pic_offset_table = 1;
+       return reg;
+     }
+   else if (GET_CODE (addr) == CONST || GET_CODE (addr) == PLUS)
+     {
+       rtx base;
+ 
+       if (GET_CODE (addr) == CONST)
+ 	{
+ 	  addr = XEXP (addr, 0);
+ 	  if (GET_CODE (addr) != PLUS)
+ 	    abort ();
+ 	}
+ 
+       if (XEXP (addr, 0) == pic_offset_table_rtx)
+ 	return orig;
+ 
+       if (reg == 0)
+ 	reg = gen_reg_rtx (Pmode);
+ 
+       base = legitimize_pic_address (XEXP (addr, 0), reg);
+       addr = legitimize_pic_address (XEXP (addr, 1),
+ 				     base == reg ? NULL_RTX : reg);
+ 
+       if (GET_CODE (addr) == CONST_INT)
+ 	return plus_constant (base, INTVAL (addr));
+ 
+       if (GET_CODE (addr) == PLUS && CONSTANT_P (XEXP (addr, 1)))
+ 	{
+ 	  base = gen_rtx (PLUS, Pmode, base, XEXP (addr, 0));
+ 	  addr = XEXP (addr, 1);
+ 	}
+ 	return gen_rtx (PLUS, Pmode, base, addr);
+     }
+   return new;
+ }
+ 
+ /* Emit insns to move operands[1] into operands[0].  */
+ 
+ void
+ emit_pic_move (operands, mode)
+      rtx *operands;
+      enum machine_mode mode;
+ {
+   rtx temp = reload_in_progress ? operands[0] : gen_reg_rtx (Pmode);
+ 
+   if (GET_CODE (operands[0]) == MEM && SYMBOLIC_CONST (operands[1]))
+     operands[1] = (rtx) force_reg (SImode, operands[1]);
+   else
+     operands[1] = legitimize_pic_address (operands[1], temp);
+ }
+ 
  /* This function generates the assembly code for function entry.
     FILE is an stdio stream to output the code to.
     SIZE is an int: how many units of temporary storage to allocate. */
***************
*** 1540,1546 ****
    return nregs == 0 || ! frame_pointer_needed;
  }
  
- 
  /* This function generates the assembly code for function exit.
     FILE is an stdio stream to output the code to.
     SIZE is an int: how many units of temporary storage to deallocate. */
--- 1317,1322 ----
***************
*** 1614,1620 ****
      {
        /* On i486, mov & pop is faster than "leave". */
  
!       if (!TARGET_386)
  	{
  	  xops[0] = frame_pointer_rtx;
  	  output_asm_insn (AS2 (mov%L2,%0,%2), xops);
--- 1390,1396 ----
      {
        /* On i486, mov & pop is faster than "leave". */
  
!       if (TARGET_486)
  	{
  	  xops[0] = frame_pointer_rtx;
  	  output_asm_insn (AS2 (mov%L2,%0,%2), xops);
